#!/usr/bin/perl -U

use Socket;
use IO::Socket;

if (@ARGV < 2){
    print "Uso: pagecount.pl SERVIDOR PORTA\n";
}

$printer = @ARGV[0];
$port    = @ARGV[1];

$ssh = osocket($printer, $port);
if ($ssh){
    $page = pagecount($ssh);
    print $page."\n";
    $ssh-close();
    exit(0);
}else {
    exit(1);
}

sub pagecount {
    my $sh = @_[0];    # Cria socket
    # envia o pedido para o socket
    send($sh, "\033%-12345X\@PJL INFO PAGECOUNT\r\n",0);
    # le a resposta do socket
    recv($sh,$RESPONSE,0xFFFFF,0);
    (my $junk,$pc) = split (/\r\n/s,$RESPONSE); # acha a contagem de paginas
    $pc =~ s/(PAGECOUNT=)?([0-9]+)/$2/g;
    return $pc;                                 # retorna a contagem de paginas
}


sub osocket {

 # Connecting to @_[0] = @arg[1] = $printer
 # On port @_[1] = 9100 JetDirect port
 # Using TCP protocol
    my $sh= new IO::Socket::INET(PeerAddr => @_[0],
                                 PeerPort => @_[1], 
                                 Proto => 'tcp');
    if (!defined($sh)) {        # O socket foi aberto?
        return undef;           # Nao! returna undef
    } else {                    # Sim!
        $sh->sockopt(SO_KEEPALIVE,1);   # Seta SO_KEEPALIVE no socket
        return $sh;             # returna o sockethandle
    }
}
