#!/usr/bin/perl -w
#################################################################################
# IBQuota.pl v0.1								#
#										#
# Rodrigo Zadra Armond <rodzadra at yahoo dot com>				#
#										#
# Adaptao do SHELL-SCRIPT IBQUOTA de Valcir Cabral				#
# http://www.ib.unicamp.br/ibquota.						#
#										#
# IBQuota.pl - Impresso Barrada por Quota 					#
#  O IBQuota.pl  um gerenciador de quota de impresso por usurio, ou seja, 	#
#  com ele cada usurio ter direito a uma quantidade especifica de folhas para #
#  imprimir. Este software  indicado, por exemplo, para instituies de ensino,#
#  em que cada aluno deva ter a sua prpria quota de impresso.			#
#										#
#  As quotas e tentativas de impresso so guardadas em um banco de dados 	#
#  (MySQL). A partir deste banco  possvel ler e atualizar informaes dos 	#
#  usurios via WEB, atravs do Gerenciador Grfico (GG) do IBQUOTA (PHP).	#
#										#
#										#
# Dependencias Perl: DBI, Socket, IO::Socket					#
# Outras Dependecias: snmp, snmp-utils, CUPS.					#
#										#
# HISTORICO									#
# V0.2 -Inclusao contagem de pginas via jetdirect (HP)				#
#	Para as impressoras HP  feita a contagem de pginas antes da impressao #
#	e apos a impressao - via JetDirect HP - PJL - retirado do script de 	#
#	autoria de Ren Lund Jensen.						#
#										#
# V0.1 -Primeira verso								#
#	Adaptao do shell-script de Valcir Cabral (www.ib.unicamp.br/ibquota)  #
#	Testado utilizando-se Drivers PS para M$-Window$ - impressora HP4100,	#
#	Servidor: RH 9.0, Samba 2.2.7a, CUPS 1.1.17 + hpij 1.5.			#
#										#
# TODO										#
# Manual de instalacao, uso de vrias impressoras				#
#										#
# BUGS 										#
# Que  isso?  (Deve ter uma pancada)						#
#										#
#										#
#################################################################################

use DBI;
use Socket;
use IO::Socket;

############################# inicio da configuracao ################################################

$LPSTAT = '/usr/bin/lpstat';					#path para lpstat
$LPRM = '/usr/bin/lprm';					#path para lprm
$MYSQL = '/usr/bin/mysql';					#path para mysql

$IPSERVIDOR = '150.164.82.250';					#IP do servidor de impressao
$PORTASERVIDOR = '9100';					#porta do servidor de impressao

$ESPERA_IMPRESSORA = "./espera_impressora_idle.sh";		#Programa para verificar se a impressora esta disponivel
$CONTA_PAGINA = "./conta_pagina_pjl.pl";			#Programa para contagem interna de paginas (JetDirect)

$VIRTUAL = 'HP4100v';						#nome da impressora virtual
$REAL = 'HP4100r';						#nome da impressora real

$SPOOL_FILA = '/var/spool/cups/';				#area de spool do cups
$TEMPO_DE_ESPERA = 10;						#tempo de espera entre cada bloco de impressao

$HOST_BANCO = 'localhost';					#host do BD
$BANCO = 'IBQUOTA';						#nome do BD
$USUARIO_BANCO = 'ibquota';					#login do BD
$SENHA_BANCO = 'senhaIBQUOTA';					#senha do BD

$LOG = "/home/rodzadra/tmp/ibquota1.2/perl/perl/IBQUOTA.log";	#arquivo de log do IBQUOTA
$DEBUG = 1;							#Debug 1(ligado),0(desligado)

################################## Teste iniciais ##################################################
if(! -e $LPSTAT)
 { print "Path do LPSTAT no  vlido: $LPSTAT\n"; 
 	exit 0;
 }
if(! -e $LPRM)
 { print "Path do LPRM no  vlido: $LPRM\n";
        exit 0;
 }
if(`$LPSTAT -v | grep "for $REAL:" | wc -l` < 1)
{ print "Impressora REAL no  vlida: $REAL\n";
	exit 0;
}
if(`$LPSTAT -v | grep "for $VIRTUAL:" | wc -l` < 1)
{ print "Impressora VIRUTAL no  vlida: $VIRTUAL\n";
        exit 0;
}
if(! -e $SPOOL_FILA)
 { print "Path do SPOOL_FILA no  vlido: $SPOOL_FILA\n";
        exit 0;
 }
if($TEMPO_DE_ESPERA < 1)
 { print "O TEMPO_DE_ESPERA deve ser maior que 0 (ZERO).\n";
	exit 0;
 }
################################### Testa conexao com banco de dados
my $dbh = DBI->connect("DBI:mysql:database=$BANCO;host=$HOST_BANCO",
                         "$USUARIO_BANCO", "$SENHA_BANCO",
                         {'RaiseError' => 1});

if($DEBUG){print "IBQUOTA iniciado com sucesso ".data()."\n";}
open LOG, ">>./IBQUOTA.log" or die "No foi possvel abrir o arquivo de log.";
	print LOG "IBQUOTA iniciado com sucesso ".data()."\n";
close(LOG);

while (1) {
	#Identifica os arquivos dos respectivos jobs da impressora VIRTUAL
	#@vet_jobs = `$LPSTAT -P $VIRTUAL | grep "$VIRTUAL" | cut -d"-" -f2|cut -d" " -f1|tail -1`;
	@vet_jobs = `$LPSTAT -P $VIRTUAL | grep "$VIRTUAL" | cut -d"-" -f2|cut -d" " -f1`;
	if($DEBUG){print "vet_jobs @vet_jobs\n";}
	
	if(@vet_jobs){
		foreach $_ (@vet_jobs) {
			s/^ |\t|\n//;
			$job = $_;
			if($job < 10){
				$nome_arq_job="d0000$job-001";
			}
			if($job > 9 and $job < 100){
				$nome_arq_job="d000$job-001";
			}
        	        if($job > 99 and $job < 1000){
				$nome_arq_job="d00$job-001";
	                }
        	        if($job > 999 and $job < 1000){
                	        $nome_arq_job="d0$job-001";
	                }
			if($DEBUG){ print "JOB No.: $job\n nome_arq_job: $nome_arq_job\n"; }
			#Identifica o dono do Job
			## limpar os espaos em branco no inicio e fim da variavel
			$_=split(" ",`$LPSTAT -P $VIRTUAL | grep $VIRTUAL-$job`);
			s/^ |\t|\n//;
			$dono=$_[1];
			if($DEBUG){ print "dono $dono\n"; }
			#@REF: 1
			#Testa se o dono do Job eh diferente de NULL
			if("SEM_DONO$dono" eq "SEM_DONO"){
				if($DEBUG){ print "JOB SEM DONO\n" };
				#Apaga o Job
				#`$LPRM -P $VIRTUAL $job`;
	                        #Grava no LOG
	                        open LOG,">>./IBQUOTA.log" or die "No foi possvel abrir o arquivo de log\n";
	                                print LOG "JOB: $job - Erro: Impossvel identificar o dono do arquivo ($nome_arq_job). Job cancelado.\n";
	                        close(LOG);
				#Insere a falha no BD
				$status = "Nao cad.";
				if(grava_log_mysql("SEM_DONO",$job,"","0",$nome_arq_job,$status) = undef){
					open LOG,">>./IBQUOTA.log" or die "No foi possvel abrir o arquivo de log\n";
						print LOG "{No foi possvel gravar no BD. REF: 1.}\n";
						print LOG "Dono: $dono Job: $job Arq:$nome_arq_job Status: $status ".data()."\n";
					close(LOG);
				}
				next;
			}
			#Testa se o arquivo temporario de impresso no existe
			# UTILIZAR File::Basename??
			#@REF 2
			if(! -e "$SPOOL_FILA$nome_arq_job"){
				if($DEBUG){ print "$SPOOL_FILA$nome_arq_job No existe!\n" };
				#Apaga o Job
				#`$LPRM -P $VIRTUAL $job`;
                        	#Grava no LOG
	                        open LOG,">>./IBQUOTA.log" or die "No foi possvel abrir o arquivo de log\n";
        	                        print LOG "JOB: $job - Erro: Arquivo no existe no SPOOL VIRTUAL ($nome_arq_job). Job cancelado.\n";
                	        close(LOG);
				#Insere a falha no BD
				$status = "Sem Arq.";
				if(grava_log_mysql($dono,$job,"0",$nome_arq_job,$status) eq undef){
					open LOG,">>./IBQUOTA.log" or die "No foi possvel abrir o arquivo de log\n";
						print LOG "{No foi possvel gravar no BD. REF: 2.}\n";
						print LOG "Dono: $dono Job: $job Arq:$nome_arq_job Status: $status ".data()."\n";
					close(LOG);
				}
				next; 
			}
			#Tenta identificar o ttulo original do aquivo %%Title
			@_ = split(" ",`cat $SPOOL_FILA$nome_arq_job | grep \%\%Title`);
			s/^ |\t|\n//;
			for($i = 1; $i < @_; $i++){
				$titulo .=$_[$i].' ';
			}
			chomp $titulo;
			if(length($titulo) eq 0){
				$titulo = "Sem Ttulo";
			}
			if($DEBUG){print "Titulo: $titulo\n";}
			#Identifica quantas pginas o Job possui (No. de pginas * No. de cpias)
			#Conta o nmero de pginas do documento
			$paginas_job = `cat "$SPOOL_FILA$nome_arq_job" | grep "%%Pages:" | tail -1 | cut -d' ' -f2`;
			#Se o nmero de pginas for negativo cancela a impresso
			#@REF 3
			if($paginas_job lt 1){
				if($DEBUG){print "No. de paginas negativo!\n"};
				#Apaga o Job
				#`$LPRM -P $VIRTUAL $job`;
        	                #Grava no LOG
	                        open LOG,">>./IBQUOTA.log" or die "No foi possvel abrir o arquivo de log\n";
        	                        print LOG "JOB: $job - Erro: No. de Pginas <= 0 ($nome_arq_job). Job cancelado.\n";
	                        close(LOG);
				#Insere a falha no BD
				$status = "Pg = 0";
				if(grava_log_mysql($dono,$job,$titulo,"0",$nome_arq_job,$status) eq undef){
					open LOG,">>./IBQUOTA.log" or die "No foi possvel abrir o arquivo de log";
						print LOG "{No foi possvel gravar no BD. REF: 3.}\n";
						print LOG "Dono: $dono Job: $JOB Arq:$nome_arq_job Status: $status ".data()."\n";
					close(LOG);
				}
				next;
			}
			if($DEBUG){print "Pginas: $paginas_job\n";}
			#Identifica o nmero de cpias deste documento
			#Obs: Fazendo testes com o m$word, OpenOffice.Org (linux), Mozilla (linux)
			#Achei que o Numero de Cpias pode estar nas variveis: NumCopies e Copies
			#OpenOffice.Org:
			#<< /NumCopies null /Policies << /NumCopies 1 >> >> setpagedevice
			#/#copies 10 def
			#Mozilla 1.5 (linux):
			#1 dict dup /NumCopies 25 put setpagedevice
			#No encontrei linha contendo copies
			#M$Word(2000):
			#/languagelevel where{pop languagelevel}{1}ifelse 2 ge{1 dict dup/NumCopies 4
			#-1 roll put setpagedevice}{userdict/#copies 3 -1 roll put}ifelse
			$O_que_procurar = 'NumCopies';
			$linha_copias = 0;
			$linha_copias = `cat "$SPOOL_FILA$nome_arq_job" | grep 'NumCopies'`;
			#Se no for encontrado um valor para 'NumCopies', utiliza-se 'copies'
			if(($linha_copias eq "NULL") || ($linha_copias eq "Null") || ($linha_copias == 0)){
				$linha_copias = `cat "$SPOOL_FILA$nome_arq_job" | grep 'copies'`;
				$O_que_procurar = 'copies';
			}
			if(length($linha_copias) gt 0){
				$_ = substr($linha_copias,index($linha_copias,$O_que_procurar));
				$_ = split(' ',$_);
				$numero_copias=$_[1];
			}
        	        if($DEBUG){print "Cpias: $numero_copias\n";}
			if($numero_copias gt 0){
				$paginas_job = $paginas_job * $numero_copias;
			}
                	if($DEBUG){print "Total pginas (pginas * cpias): $paginas_job\n";}
			#Identifica se o dono do Job esta cadastrado no BD
			$sth = $dbh->prepare("SELECT login FROM usuario WHERE login='$dono'");
			$sth->execute() or die $sth->errstr;
			$ref = $sth->fetchrow_hashref();
			$dono_nobanco = $ref->{'login'};
			if($DEBUG){print "CADASTRADO: $dono_nobanco\n";}
			#Se no estiver, grava o log, apaga o arquivo e volta
			#@REF 4
			if("NAOCADASTRADO$dono_nobanco" eq "NAOCADASTRADO"){
				#Apaga o Job
				`$LPRM -P $VIRTUAL $job`;
                	        #Grava no LOG
				open LOG,">>./IBQUOTA.log" or die "No foi possvel abrir o arquivo de log\n";
					print LOG "JOB: $job : Usurio ($dono) no cadastrado ($nome_arq_job). Job cancelado.\n";
				close(LOG);
				#Insere a falha no BD
				if($DEBUG){print "Usuario No cadastrado: $dono_nobanco\n";}
				$status = "Nao cad.";
				if(grava_log_mysql($dono,$job,$titulo,$paginas_job,$nome_arq_job,$status) eq undef){
					open LOG,">>./IBQUOTA.log" or die "No foi possvel abrir o arquivo de log";
						print LOG "{No foi possvel gravar no BD. REF: 4.}\n";
						print LOG "Dono: $dono Job: $job Arq:$nome_arq_job Status: $status ".data()."\n";
					close(LOG);
				}
	                        next;
			}
			#Verifica se o usuario tem quota infinita
        	        $sth = $dbh->prepare("SELECT quota_infinita FROM usuario WHERE login='$dono'");
                	$sth->execute();
			$ref = $sth->fetchrow_hashref();
			$quota_infinita = $ref->{'quota_infinita'};
			if($DEBUG){print "QUOTA infinita: $quota_infinita\n";}
			#Se o usuario tiver no tiver quota infinita procura a quota atual
			#e confere se o usuario tem quota suficiente para a impressao
			if($quota_infinita eq 0){
	#			$sth = $dbh->prepare("SELECT (quota - $paginas_job) as quota FROM usuario WHERE login='$dono'");
				$sth = $dbh->prepare("SELECT quota FROM usuario WHERE login='$dono'");
				$sth->execute();
				$ref = $sth->fetchrow_hashref();
				$quota = $ref->{'quota'};
				$quota_usuario = ($quota - $paginas_job);
				if($DEBUG){print "QUOTA atual: $quota_usuario\n";}
				#Se a quota for igual ou maior que o No. de paginas imprime, grava no log e BD
				#@REF 5
				if($quota_usuario ge 0){
	                                #Manda o Job para a impressora REAL
        	                        #@REF 5
                	                #Verifica contador interno da impressora
					readpipe "$ESPERA_IMPRESSORA $IPSERVIDOR";      #espera a impressora ficar disponivel
					$CONTADOR_INTERNO_IN = readpipe "$CONTA_PAGINA $IPSERVIDOR $PORTASERVIDOR"; #faz a contagem interna
					#Envia o JOB para a impressora REAL
					`cat "$SPOOL_FILA$nome_arq_job" | lpr -P $REAL -C $dono`;
					#Apaga o JOB da impressora VIRTUAL
					`$LPRM -P $VIRTUAL $job`;
					#Espera a impressora ficar disponivel e verifica o contador interno de paginas da impressora
					readpipe "$ESPERA_IMPRESSORA $IPSERVIDOR";
					$CONTADOR_INTERNO_OUT = readpipe "$CONTA_PAGINA $IPSERVIDOR $PORTASERVIDOR";
					chomp $CONTADOR_INTERNO_IN;
					chomp $CONTADOR_INTERNO_OUT;
					#compara o numero de paginas impressas (contador interno) com o numero de paginas do documento
					#em todo o caso considera sempre o menor numero para efeitos de cobranca
					$CONTADOR_INTERNO = (int($CONTADOR_INTERNO_IN) - int($CONTADOR_INTERNO_OUT));
					if($CONTADOR_INTERNO < $paginas_job){
						$paginas_job_TMP = $CONTADOR_INTERNO;
						$status = "OK";
					} else {
						$paginas_job_TMP = $paginas_job;
						$status = "Err $CONTADOR_INTERNO|$paginas_job";
					}
					if($DEBUG){print "Paginas do Documento.: $paginas_job\n";
						print "Paginas Impressas....: $CONTADOR_INTERNO\n";
						print "Paginas No Impressas: $paginas_job_TMP\n";}
					#Grava o LOG
					open LOG,">>./IBQUOTA.log" or die "No foi possvel abrir o arquivo de log\n";
						print LOG "JOB: $job : usu ($dono) arq ($nome_arq_job) pag ($paginas_job) quo ($quota_usuario). Impresso.\n";
					close(LOG);
					#Insere no BD
					#$status = "OK";
					$paginas_job = $paginas_job_TMP; ## temporario
					if(atualiza_log_mysql($dono,$paginas_job) eq undef){
						open LOG,">>./IBQUOTA.log" or die "No foi possvel abrir o arquivo de log\n";
							print LOG "{No foi possvel gravar no BD. REF: 5.}\n";
							print LOG "Dono: $dono Job: $job Arq:$nome_arq_job Status: $status ".data()."\n";
						close(LOG);
					}			
				} else { #O usuario no tem quota
					#Apaga o JOB
					#@REF 6
					#`$LPRM -P $VIRTUAL $job`;
					#Grava o LOG
					open LOG,">>./IBQUOTA.log" or die "No foi possvel abrir o arquivo de log\n";
						print LOG "JOB: $job - Sem Quota : usu ($dono) arq ($nome_arq_job) pag ($paginas_job) quo ($quota_usuario). Job Cancelado.\n";
					close(LOG);
					#Insere no BD
					$status = "Sem Quota";
					if(grava_log_mysql($dono,$job,$titulo,$paginas_job,$nome_arq_job,$status) eq undef){
						open LOG,">>./IBQUOTA.log" or die "No foi possvel abrir o arquivo de log";
							print LOG "{No foi possvel gravar no BD. REF: 6.}\n";
							print LOG "Dono: $dono Job: $job Arq:$nome_arq_job Status: $status ".data()."\n";
						close(LOG);
					#Manda mensagem
					#VIA SMB - FALTA FAZER
					}
				}			
			} else { #O usuario tem quota infinita
				#Manda o Job para a impressora REAL
				#@REF 7
				#Verifica contador interno da impressora
				readpipe "$ESPERA_IMPRESSORA $IPSERVIDOR";	#espera a impressora ficar disponivel
				$CONTADOR_INTERNO_IN = readpipe "$CONTA_PAGINA $IPSERVIDOR $PORTASERVIDOR"; #faz a contagem interna
				#Envia o JOB para a impressora REAL
				`cat "$SPOOL_FILA$nome_arq_job" | lpr -P $REAL -C $dono`;
				#Apaga o JOB da impressora VIRTUAL
				`$LPRM -P $VIRTUAL $job`;
				#Espera a impressora ficar disponivel e verifica o contador interno de paginas da impressora
				readpipe "$ESPERA_IMPRESSORA $IPSERVIDOR";
                                $CONTADOR_INTERNO_OUT = readpipe "$CONTA_PAGINA $IPSERVIDOR $PORTASERVIDOR"; 
				chomp $CONTADOR_INTERNO_IN;
				chomp $CONTADOR_INTERNO_OUT;
				#compara o numero de paginas impressas (contador interno) com o numero de paginas do documento
				#em todo o caso considera sempre o menor numero para efeitos de cobranca
				$CONTADOR_INTERNO = (int($CONTADOR_INTERNO_IN) - int($CONTADOR_INTERNO_OUT));
				if($CONTADOR_INTERNO < $paginas_job){
					$paginas_job_TMP = $CONTADOR_INTERNO;
					$status = "OK";
				} else {
					$paginas_job_TMP = $paginas_job;
					$status = "Err $CONTADOR_INTERNO|$paginas_job";
				}
				if($DEBUG){print "Paginas do Documento.: $paginas_job\n";
					   print "Paginas Impressas....: $CONTADOR_INTERNO\n";
					   print "Paginas No Impressas: $paginas_job_TMP\n";}			
				#Grava o LOG
				open LOG,">>./IBQUOTA.log" or die "No foi possvel abrir o arquivo de log\n";
					print LOG "JOB: $job : usu ($dono) arq ($nome_arq_job) pag ($paginas_job) quo ($quota_usuario). Impresso.\n";
				close(LOG);
				#Insere no BD
				#$status = "OK";
				$paginas_job = $paginas_job_TMP; ## temporario
				if(grava_log_mysql($dono,$job,$titulo,$paginas_job,$nome_arq_job,$status) eq undef){
					open LOG,">>./IBQUOTA.log" or die "No foi possvel abrir o arquivo de log";
						print LOG "{No foi possvel gravar no BD. REF: 7. }\n";
						print LOG "Dono: $dono Job: $job Arq:$nome_arq_job Status: $status ".data()."\n";
					close(LOG);
				}
			}
		#libera BD
		if($DEBUG){print "Liberando DB\n"};
		$sth->finish();
		}
		#Limpa todas as variveis
		limpa_var(); 	
	}
	#Aguarda
	sleep $TEMPO_DE_ESPERA;
}

#Limpa as variveis
sub limpa_var{
	undef($dono);
	undef($job);
	undef($nome_arq_job);
	undef($paginas_job);
	undef($quota_usuarios);
	undef($quota_infinita);
	undef($status);
	undef(@vet_jobs);
	undef($linha_copias);
	undef($numero_copias);
	undef($dono_nobanco);
	undef($i);
	undef($titulo);
	undef($CONTADOR_INTERNO_IN);
	undef($CONTADOR_INTERNO_OUT);
}

#Gera hora atual
sub hora{
        my ($seg,$min,$hora,$dia,$mes,$ano,@nada) = localtime(time);
        return $hora.':'.$min.':'.$seg;
}

#Gera data atual
sub data{
	my ($seg,$min,$hora,$dia,$mes,$ano,@nada) = localtime(time);
        return ($ano+1900).'-'.($mes+1).'/'.$dia;
}

#Grava na tabela logi
sub grava_log_mysql(){
	my ($login,$job,$titulo,$paginas,$arquivo,$status) = @_;
	my $data = data();
	my $hora = hora();
	my $rows = 0;
	$query ="INSERT INTO logi (cod,login,data,hora,job,titulo,paginas,arquivo,status) VALUES ('0','$login','$data','$hora','$job','$titulo','$paginas','$arquivo','$status')";
	my $sth = $dbh->prepare($query) or return undef;
	$sth->execute() or return undef;
	($rows == 0) ? "0E0" : $rows;	
}

#Atualiza quota
sub atualiza_log_mysql(){
	my ($login,$quota) = @_;
	my $data = data();
	my $hora = hora();
	my $rows = 0;
	$query ="UPDATE usuario SET quota = '$quota' WHERE login='$login'";
	$sth = $dbh->prepare($query) or return undef;
	$sth->execute() or return undef;
	($rows == 0) ? "0E0" : $rows;
}
