#!/bin/bash
#
# Startup script for the IBQuota.pl
#
# description: IBQUOTA is Impressao Barrada por QUOTA.
# processname: ibquota.pl
# pidfile: /var/run/ibquota.pid
# config: /usr/local/bin/ibquota

# Source function library.
. /etc/rc.d/init.d/functions

# Path to the ibquota script.
prog=/usr/local/bin/ibquota.pl

start() {
        echo -n $"Starting $prog: "
        daemon $prog
        RETVAL=$?
        echo
        [ $RETVAL = 0 ] && touch /var/lock/subsys/ibquota
        return $RETVAL
}
stop() {
        echo -n $"Stopping $prog: "
        killproc $prog
        RETVAL=$?
        echo
        [ $RETVAL = 0 ] && rm -f /var/lock/subsys/ibquota
/var/run/ibquota.pid
}
reload() {
        echo -n $"Reloading $prog: "
        killproc $prog -HUP
        RETVAL=$?
        echo
}

# See how we were called.
case "$1" in
  start)
        start
        ;;
  stop)
        stop
        ;;
  status)
        status $prog
        RETVAL=$?
        ;;
  restart)
        stop
        start
        ;;
  reload)
        reload
        ;;
  *)
        echo $"Usage: $prog {start|stop|restart|status}"
        exit 1
esac

exit $RETVAL
